# Generated by Django 3.2.16 on 2022-11-04 21:36

import django.contrib.postgres.fields
import django.contrib.sites.managers
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
        ('sites', '0002_alter_domain_unique'),
        ('ldap', '0001_preferences'),
    ]

    operations = [
        migrations.CreateModel(
            name='LDAPMappingSet',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('extended_data', models.JSONField(default=dict, editable=False)),
                ('base_dn', models.CharField(max_length=255, verbose_name='Base DN')),
                ('object_classes', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=255, verbose_name='Object class'), size=None, verbose_name='Object classes')),
                ('matching_mode', models.CharField(choices=[('AND', 'All fields must match'), ('OR', 'Any one field must match')], max_length=7, verbose_name='Matching mode')),
                ('model', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='ldap_mapping_set', to='contenttypes.contenttype')),
                ('site', models.ForeignKey(default=1, editable=False, on_delete=django.db.models.deletion.CASCADE, to='sites.site')),
            ],
            options={
                'verbose_name': 'LDAP mapping set',
                'verbose_name_plural': 'LDAP mapping sets',
            },
            managers=[
                ('objects', django.contrib.sites.managers.CurrentSiteManager()),
            ],
        ),
        migrations.CreateModel(
            name='LDAPFieldMapping',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('extended_data', models.JSONField(default=dict, editable=False)),
                ('ldap_attribute', models.CharField(max_length=255, verbose_name='LDAP attribute')),
                ('read_regex', models.CharField(max_length=255, verbose_name='Read regex')),
                ('write_template', models.CharField(max_length=255, verbose_name='Write template')),
                ('match', models.BooleanField(default=False, verbose_name='Use for matching')),
                ('include_in_rdn', models.BooleanField(default=False, verbose_name='Include in RDN')),
                ('mapping_set', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='ldap_field_mappings', to='ldap.ldapmappingset')),
                ('site', models.ForeignKey(default=1, editable=False, on_delete=django.db.models.deletion.CASCADE, to='sites.site')),
            ],
            options={
                'verbose_name': 'LDAP field mapping',
                'verbose_name_plural': 'LDAP field mappings',
            },
            managers=[
                ('objects', django.contrib.sites.managers.CurrentSiteManager()),
            ],
        ),
        migrations.AddConstraint(
            model_name='ldapmappingset',
            constraint=models.UniqueConstraint(fields=('model_id', 'site_id'), name='uniq_model_per_site'),
        ),
        migrations.AddConstraint(
            model_name='ldapfieldmapping',
            constraint=models.UniqueConstraint(fields=('mapping_set_id', 'ldap_attribute'), name='uniq_attr_per_model'),
        ),
    ]
